(function(){

    var apply = require('apply.js');

    var action_middleware = function(dispatch, next, end, context){
        return function(name, options){
            if(typeof name !== 'string') {
                return next(arguments);
            }
            if (name.indexOf('.') === -1) name = [context.moduleName, name];
            else name = name.split('.');
            if (!context.modules[name[0]]) throw 'unknown module name ' + name[0];
            if (!context.modules[name[0]][name[1]]) throw 'unknown action name ' + name[1] + ' of ' + name[0];
            if(!context.modules[name[0]][name[1]].isAction ) throw 'the method '+name[1]+' of '+name[0]+' is not an action';
            return apply(context.modules[name[0]][name[1]], Array.prototype.slice.call(arguments,1), context.modules[name[0]]);
        };
    };

    if (typeof module === 'object' && module.exports) {
        module.exports = action_middleware
    }
    else if (typeof define === 'function' && define.amd) {
        define(function () { return action_middleware })
    }

})();
